;7-tile0 bitmap
;8,9-tilemap
	device zxspectrum128
        ORG #6000
begin
 include "TSPor.inc"
st:incbin "sintw.bin"

 ld a,6,bc,SysConfig:out (c),a
 ld bc,TSConfig
 xor a
 out (c),a

 LD	BC,VConfig
 LD	A,VID_NOGFX
 OUT	(C),A

; ld hl,song:call INIT

 ;open FMAddr access from 0x8000
 ld bc, FMAddr
 ld a, %00010000;0x18
 out (c), a
;load CRAM
 ld de,0
 ld hl,plasm_pal_b
 ld bc,plasm_pal_e-plasm_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
;PalSel = %00 //   0   0
;PalSel          EQU	#07AF
 ld bc,PalSel
 xor a
 out (c),a

; ld hl,pic1,a,$20:call unpack
; ld hl,pic2,a,$21:call unpack
; ld hl,pic3,a,$22:call unpack
; ld hl,pic4,a,$23:call unpack

; ld a,$24
;fill_vram:
; call clear_page_dma
; inc a
; cp $29
; jr nz,fill_vram
 
 ld  bc,VPage,a,$20:out (c),a
 ld bc,Page3:out (c),a
 
VID_16C         equ $01
VID_256C        equ $02
VID_360X288     equ $C0
PLANE0_MODE		equ VID_256C
RASTER_SIZE		equ VID_360X288
VID_NOGFX       equ $20
VID_320X200     equ $40

 LD	BC,VConfig
 LD	A,VID_320X200|VID_256C
 OUT	(C),A

TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80

INTMASK         equ $2AAF

; ld a,1,bc,Border:out (c),a
 ld hl,twp,de,$4000:call dzx7_standard
 ld hl,$C000,de,$c001,bc,16383,(hl),l:ldir
  ld de,$C000+160-64*0,hl,$4300;twist+768
  ld a,32
copylp:
 push de
 ld bc,128:ldir
 pop de
 inc d,d
 dec a
 jr nz,copylp
; jr $
;-------------------intra!-------------------
	di
	xor a
	ld bc,HSINT
	out (c),a
	ld bc,VSINTL
	out (c),a
	ld bc,VSINTH
	out (c),a

	ld a,$5B
	ld i,a
	ld hl,int_intro
	ld ($5Bff),hl
	im 2
 ei

 jr $

;--------------------------------------------
int_intro:
; call PLAY

;iv2:ld hl,0
; inc h,h,h
; dec l,l
; ld(iv2+1),hl
; ld(iv1+1),hl

;    hl=s(b)+s(c)
;    c-5
;    b+4

iv3: ld bc,0
 ld a,b:add a,4:ld b,a
 ld (v_b+1),a
 ld a,c:sub 5:ld c,a
 ld (iv3+1),bc
 ld h,st/256
 ld d,0
 ld l,b
 ld a,(hl)
 ld l,c
 add a,(hl)
 jr nc,no_id
 inc d
no_id
 ld e,a
 ld (hl_v+1),de
 ld a,(v_c0+1):inc a:ld (v_c0+1),a
 xor a:ld (v_y+1),a
;-----------------------
	ld	hl,30
	ld	bc,VSINTL
	out	(c),l
	ld	bc,VSINTH
	out	(c),h
	ld	hl,im_blank_off
	ld	(#5bff),hl

	ld a,1
	ld bc,INTMASK
	out (c),a
	ei
	ret

im_blank_off
		di
		ld bc,INTMASK
		ld a,3
		out (c),a

		ld hl,288+30;
		ld bc,VSINTL
		out (c),l
		ld bc,VSINTH
		out (c),h
		ld hl,im_blank_ex
		ld (#5Bff),hl
		ld hl,int
		ld (#5Bfd),hl

		ei
		ret

im_blank_ex
		di
		xor a
		ld bc,VSINTL
		out (c),a
		ld bc,VSINTH
		out (c),a
		inc a
		ld bc,INTMASK
		out (c),a

		ld hl,int_intro
		ld ($5BFF),hl

		ei
		ret


int:
	exx
	exa
hl_v:ld de,0
;    For y=0 To 480-280
;      px=s((b+hl>>8)&255)
 ld h,st/256
 ld a,d
v_b:add a,0
 ld l,a
 ld a,(hl)
 ld	bc,GXOffsL
 out (c),a
 inc b
 xor a
 out	(c),a

; hl+$13
 ld a,e:add a,$13:ld e,a
 jr nc,no_inc_d
 inc d
no_inc_d:
 ld (hl_v+1),de
;      vv.a=s((c0+y>>4)&255)+(hl>>7)&255
v_y:ld a,0
 inc a:ld (v_y+1),a
; and 127
 sra a
 and 127
 sra a
 sra a
 sra a
; and 127
v_c0:add a,0
 ld l,a
 ld l,(hl)

 sra d:rr e
 sra d:rr e
 sra d:rr e
 sra d:rr e
 sra d:rr e
 sra d:rr e
 sra d:rr e

 ld a,e
 add a,l
 and 31

	 ld	bc,GYOffsL;   
	 out	(c),a
	 xor a
	 inc b;ld	bc,GYOffsH;   
	 out	(c),a

; ld (hl_v+1),de
;      GrabImage(0,1,0,vv&31,128,1)
;      DrawImage(ImageID(1),px,y)
;
;    Next y
;       c0+1


;GXOffsL         EQU	#02AF
;GXOffsH         EQU	#03AF
;GYOffsL         EQU	#04AF
;GYOffsH         EQU	#05AF

	 exa
	 exx
	 ei:ret
;--------------end interrupt

;clear_page_dma:
; push af
; ld bc,Page3
; out (c),a
; ld hl,0;+$0101
; ld (#c000),hl
; ld bc,#1AAF
; ld hl,$C000
; out (c),l;DMASAddrL    EQU	#1AAF
; inc b
; out (c),h;l;DMASAddrH    EQU	#1BAF
; inc b
;
; out (c),a;h;DMASAddrX    EQU	#1CAF
; inc b
;;TSL:;2.  DMADAddrL   2,     8194 ,  2 ,  .  Fill  Src  Dest  
; ld l,2
; out (c),l;DMADAddrL    EQU	#1DAF
; inc b
; out (c),h;l;DMADAddrH    EQU	#1EAF
; inc b
; out (c),a;h;DMADAddrX    EQU	#1FAF
; ld l,255
; ld b,#26
;
;;		defb #28,200	;
;;		defb #26,#ff	;
;;		defb #27,%00000100    ; DMA_FILL
;
; out (c),l;DMALen    EQU	#26AF
; inc b
; inc b
; ld a,31;15+2;(15+1)*2=32, 32*512=16384
; out (c),a;;l;DMANum    EQU	#28AF
; dec b
; ld a,%00000100; FILL->RAM
; out (c),a;DMACtrl   EQU	#27AF
;waitdma1:
; inf
; jp m,waitdma1
; pop af
; ret
;----------------------------------------------------
;unpack:
; ld bc,Page3:out (c),a
; ld de,$C000:call dzx7_standard
; ret
;zx7:include "zx7.a80"

plasm_pal_b:
; dw 0
; dw 1024*31;+32*31+31;R.G.B-0
; incbin "twpal.bin"
; dw 1024*0+32*0+0;R.G.B-0
i=0
j=31
 dup 31
 dw 1024*i+32*i;+i;R.G.B-0
 dw 1024*j+32*j;+j;R.G.B-0
i=i+1
j=j-1
edup

plasm_pal_e:
;plyer: include "PTxPlay.a80"
;song: incbin "nq-Test.ym.pt3"
zx7:include "zx7.a80"
twp:incbin "TW.RAW.zx7"
;twist: incbin "Tw.raw"
end
	display /d,end-begin
	savebin "chess.bin",begin,end-begin

